Tool: colab_enterprise_create_notebook_runtime
Creates a Colab Enterprise runtime that can be used to run code from your notebook (IPYNB file). Use this tool to provision a notebook runtime for a specific user that can be used to run code from on notebooks.
The following sample demonstrate how to use curl to invoke the colab_enterprise_create_notebook_runtime MCP tool.
| Curl Request |
|---|
curl --location 'https://aiplatform.googleapis.com/mcp/generate' \ --header 'content-type: application/json' \ --header 'accept: application/json, text/event-stream' \ --data '{ "method": "tools/call", "params": { "name": "colab_enterprise_create_notebook_runtime", "arguments": { // provide these details according to the tool's MCP specification } }, "jsonrpc": "2.0", "id": 1 }' |
Input Schema
Request message for NotebookService.AssignNotebookRuntime.
AssignNotebookRuntimeRequest
| JSON representation |
|---|
{
"parent": string,
"notebookRuntimeTemplate": string,
"notebookRuntime": {
object ( |
| Fields | |
|---|---|
parent |
Required. The resource name of the Location to get the NotebookRuntime assignment. Format: |
notebookRuntimeTemplate |
Required. The resource name of the NotebookRuntimeTemplate based on which a NotebookRuntime will be assigned (reuse or create a new one). |
notebookRuntime |
Required. Provide runtime specific information (e.g. runtime owner, notebook id) used for NotebookRuntime assignment. |
notebookRuntimeId |
Optional. User specified ID for the notebook runtime. |
NotebookRuntime
| JSON representation |
|---|
{ "name": string, "runtimeUser": string, "notebookRuntimeTemplateRef": { object ( |
| Fields | |
|---|---|
name |
Output only. The resource name of the NotebookRuntime. |
runtimeUser |
Required. The user email of the NotebookRuntime. |
notebookRuntimeTemplateRef |
Output only. The pointer to NotebookRuntimeTemplate this NotebookRuntime is created from. |
proxyUri |
Output only. The proxy endpoint used to access the NotebookRuntime. |
createTime |
Output only. Timestamp when this NotebookRuntime was created. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: |
updateTime |
Output only. Timestamp when this NotebookRuntime was most recently updated. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: |
healthState |
Output only. The health state of the NotebookRuntime. |
displayName |
Required. The display name of the NotebookRuntime. The name can be up to 128 characters long and can consist of any UTF-8 characters. |
description |
The description of the NotebookRuntime. |
serviceAccount |
Output only. Deprecated: This field is no longer used and the "Vertex AI Notebook Service Account" (service-PROJECT_NUMBER@gcp-sa-aiplatform-vm.iam.gserviceaccount.com) is used for the runtime workload identity. See https://cloud.google.com/iam/docs/service-agents#vertex-ai-notebook-service-account for more details. The service account that the NotebookRuntime workload runs as. |
runtimeState |
Output only. The runtime (instance) state of the NotebookRuntime. |
isUpgradable |
Output only. Whether NotebookRuntime is upgradable. |
labels |
The labels with user-defined metadata to organize your NotebookRuntime. Label keys and values can be no longer than 64 characters (Unicode codepoints), can only contain lowercase letters, numeric characters, underscores and dashes. International characters are allowed. No more than 64 user labels can be associated with one NotebookRuntime (System labels are excluded). See https://goo.gl/xmQnxf for more information and examples of labels. System reserved label keys are prefixed with "aiplatform.googleapis.com/" and are immutable. Following system labels exist for NotebookRuntime:
An object containing a list of |
expirationTime |
Output only. Timestamp when this NotebookRuntime will be expired: 1. System Predefined NotebookRuntime: 24 hours after creation. After expiration, system predifined runtime will be deleted. 2. User created NotebookRuntime: 6 months after last upgrade. After expiration, user created runtime will be stopped and allowed for upgrade. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: |
version |
Output only. The VM os image version of NotebookRuntime. |
notebookRuntimeType |
Output only. The type of the notebook runtime. |
machineSpec |
Output only. The specification of a single machine used by the notebook runtime. |
dataPersistentDiskSpec |
Output only. The specification of [persistent disk][https://cloud.google.com/compute/docs/disks/persistent-disks] attached to the notebook runtime as data disk storage. |
networkSpec |
Output only. Network spec of the notebook runtime. |
idleShutdownConfig |
Output only. The idle shutdown configuration of the notebook runtime. |
eucConfig |
Output only. EUC configuration of the notebook runtime. |
shieldedVmConfig |
Output only. Runtime Shielded VM spec. |
networkTags[] |
Optional. The Compute Engine tags to add to runtime (see Tagging instances). |
softwareConfig |
Output only. Software config of the notebook runtime. |
encryptionSpec |
Output only. Customer-managed encryption key spec for the notebook runtime. |
satisfiesPzs |
Output only. Reserved for future use. |
satisfiesPzi |
Output only. Reserved for future use. |
NotebookRuntimeTemplateRef
| JSON representation |
|---|
{ "notebookRuntimeTemplate": string } |
| Fields | |
|---|---|
notebookRuntimeTemplate |
Immutable. A resource name of the NotebookRuntimeTemplate. |
Timestamp
| JSON representation |
|---|
{ "seconds": string, "nanos": integer } |
| Fields | |
|---|---|
seconds |
Represents seconds of UTC time since Unix epoch 1970-01-01T00:00:00Z. Must be between -62135596800 and 253402300799 inclusive (which corresponds to 0001-01-01T00:00:00Z to 9999-12-31T23:59:59Z). |
nanos |
Non-negative fractions of a second at nanosecond resolution. This field is the nanosecond portion of the duration, not an alternative to seconds. Negative second values with fractions must still have non-negative nanos values that count forward in time. Must be between 0 and 999,999,999 inclusive. |
LabelsEntry
| JSON representation |
|---|
{ "key": string, "value": string } |
| Fields | |
|---|---|
key |
|
value |
|
MachineSpec
| JSON representation |
|---|
{ "machineType": string, "acceleratorType": enum ( |
| Fields | |
|---|---|
machineType |
Immutable. The type of the machine. See the list of machine types supported for prediction See the list of machine types supported for custom training. For |
acceleratorType |
Immutable. The type of accelerator(s) that may be attached to the machine as per |
acceleratorCount |
The number of accelerators to attach to the machine. For accelerator optimized machine types (https://cloud.google.com/compute/docs/accelerator-optimized-machines), One may set the accelerator_count from 1 to N for machine with N GPUs. If accelerator_count is less than or equal to N / 2, Vertex will co-schedule the replicas of the model into the same VM to save cost. For example, if the machine type is a3-highgpu-8g, which has 8 H100 GPUs, one can set accelerator_count to 1 to 8. If accelerator_count is 1, 2, 3, or 4, Vertex will co-schedule 8, 4, 2, or 2 replicas of the model into the same VM to save cost. When co-scheduling, CPU, memory and storage on the VM will be distributed to replicas on the VM. For example, one can expect a co-scheduled replica requesting 2 GPUs out of a 8-GPU VM will receive 25% of the CPU, memory and storage of the VM. Note that the feature is not compatible with [multihost_gpu_node_count][]. When multihost_gpu_node_count is set, the co-scheduling will not be enabled. |
gpuPartitionSize |
Optional. Immutable. The Nvidia GPU partition size. When specified, the requested accelerators will be partitioned into smaller GPU partitions. For example, if the request is for 8 units of NVIDIA A100 GPUs, and gpu_partition_size="1g.10gb", the service will create 8 * 7 = 56 partitioned MIG instances. The partition size must be a value supported by the requested accelerator. Refer to Nvidia GPU Partitioning for the available partition sizes. If set, the accelerator_count should be set to 1. |
tpuTopology |
Immutable. The topology of the TPUs. Corresponds to the TPU topologies available from GKE. (Example: tpu_topology: "2x2x1"). |
reservationAffinity |
Optional. Immutable. Configuration controlling how this resource pool consumes reservation. |
ReservationAffinity
| JSON representation |
|---|
{
"reservationAffinityType": enum ( |
| Fields | |
|---|---|
reservationAffinityType |
Required. Specifies the reservation affinity type. |
key |
Optional. Corresponds to the label key of a reservation resource. To target a SPECIFIC_RESERVATION by name, use |
values[] |
Optional. Corresponds to the label values of a reservation resource. This must be the full resource name of the reservation or reservation block. |
PersistentDiskSpec
| JSON representation |
|---|
{ "diskType": string, "diskSizeGb": string } |
| Fields | |
|---|---|
diskType |
Type of the disk (default is "pd-standard"). Valid values: "pd-ssd" (Persistent Disk Solid State Drive) "pd-standard" (Persistent Disk Hard Disk Drive) "pd-balanced" (Balanced Persistent Disk) "pd-extreme" (Extreme Persistent Disk) |
diskSizeGb |
Size in GB of the disk (default is 100GB). |
NetworkSpec
| JSON representation |
|---|
{ "enableInternetAccess": boolean, "network": string, "subnetwork": string } |
| Fields | |
|---|---|
enableInternetAccess |
Whether to enable public internet access. Default false. |
network |
The full name of the Google Compute Engine network |
subnetwork |
The name of the subnet that this instance is in. Format: |
NotebookIdleShutdownConfig
| JSON representation |
|---|
{ "idleTimeout": string, "idleShutdownDisabled": boolean } |
| Fields | |
|---|---|
idleTimeout |
Required. Duration is accurate to the second. In Notebook, Idle Timeout is accurate to minute so the range of idle_timeout (second) is: 10 * 60 ~ 1440 * 60. A duration in seconds with up to nine fractional digits, ending with ' |
idleShutdownDisabled |
Whether Idle Shutdown is disabled in this NotebookRuntimeTemplate. |
Duration
| JSON representation |
|---|
{ "seconds": string, "nanos": integer } |
| Fields | |
|---|---|
seconds |
Signed seconds of the span of time. Must be from -315,576,000,000 to +315,576,000,000 inclusive. Note: these bounds are computed from: 60 sec/min * 60 min/hr * 24 hr/day * 365.25 days/year * 10000 years |
nanos |
Signed fractions of a second at nanosecond resolution of the span of time. Durations less than one second are represented with a 0 |
NotebookEucConfig
| JSON representation |
|---|
{ "eucDisabled": boolean, "bypassActasCheck": boolean } |
| Fields | |
|---|---|
eucDisabled |
Input only. Whether EUC is disabled in this NotebookRuntimeTemplate. In proto3, the default value of a boolean is false. In this way, by default EUC will be enabled for NotebookRuntimeTemplate. |
bypassActasCheck |
Output only. Whether ActAs check is bypassed for service account attached to the VM. If false, we need ActAs check for the default Compute Engine Service account. When a Runtime is created, a VM is allocated using Default Compute Engine Service Account. Any user requesting to use this Runtime requires Service Account User (ActAs) permission over this SA. If true, Runtime owner is using EUC and does not require the above permission as VM no longer use default Compute Engine SA, but a P4SA. |
ShieldedVmConfig
| JSON representation |
|---|
{ "enableSecureBoot": boolean } |
| Fields | |
|---|---|
enableSecureBoot |
Defines whether the instance has Secure Boot enabled. Secure Boot helps ensure that the system only runs authentic software by verifying the digital signature of all boot components, and halting the boot process if signature verification fails. |
NotebookSoftwareConfig
| JSON representation |
|---|
{ "env": [ { object ( |
| Fields | |
|---|---|
env[] |
Optional. Environment variables to be passed to the container. Maximum limit is 100. |
postStartupScriptConfig |
Optional. Post startup script config. |
Union field
|
|
colabImage |
Optional. Google-managed NotebookRuntime colab image. |
ColabImage
| JSON representation |
|---|
{ "releaseName": string, "description": string } |
| Fields | |
|---|---|
releaseName |
Optional. The release name of the NotebookRuntime Colab image, e.g. "py310". If not specified, detault to the latest release. |
description |
Output only. A human-readable description of the specified colab image release, populated by the system. Example: "Python 3.10", "Latest - current Python 3.11" |
EnvVar
| JSON representation |
|---|
{ "name": string, "value": string } |
| Fields | |
|---|---|
name |
Required. Name of the environment variable. Must be a valid C identifier. |
value |
Required. Variables that reference a $(VAR_NAME) are expanded using the previous defined environment variables in the container and any service environment variables. If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME). Escaped references will never be expanded, regardless of whether the variable exists or not. |
PostStartupScriptConfig
| JSON representation |
|---|
{
"postStartupScript": string,
"postStartupScriptUrl": string,
"postStartupScriptBehavior": enum ( |
| Fields | |
|---|---|
postStartupScript |
Optional. Post startup script to run after runtime is started. |
postStartupScriptUrl |
Optional. Post startup script url to download. Example: |
postStartupScriptBehavior |
Optional. Post startup script behavior that defines download and execution behavior. |
EncryptionSpec
| JSON representation |
|---|
{ "kmsKeyName": string } |
| Fields | |
|---|---|
kmsKeyName |
Required. Resource name of the Cloud KMS key used to protect the resource. The Cloud KMS key must be in the same region as the resource. It must have the format |
Output Schema
This resource represents a long-running operation that is the result of a network API call.
Operation
| JSON representation |
|---|
{ "name": string, "metadata": { "@type": string, field1: ..., ... }, "done": boolean, // Union field |
| Fields | |
|---|---|
name |
The server-assigned name, which is only unique within the same service that originally returns it. If you use the default HTTP mapping, the |
metadata |
Service-specific metadata associated with the operation. It typically contains progress information and common metadata such as create time. Some services might not provide such metadata. Any method that returns a long-running operation should document the metadata type, if any. An object containing fields of an arbitrary type. An additional field |
done |
If the value is |
Union field result. The operation result, which can be either an error or a valid response. If done == false, neither error nor response is set. If done == true, exactly one of error or response can be set. Some services might not provide the result. result can be only one of the following: |
|
error |
The error result of the operation in case of failure or cancellation. |
response |
The normal, successful response of the operation. If the original method returns no data on success, such as An object containing fields of an arbitrary type. An additional field |
Any
| JSON representation |
|---|
{ "typeUrl": string, "value": string } |
| Fields | |
|---|---|
typeUrl |
Identifies the type of the serialized Protobuf message with a URI reference consisting of a prefix ending in a slash and the fully-qualified type name. Example: type.googleapis.com/google.protobuf.StringValue This string must contain at least one The prefix is arbitrary and Protobuf implementations are expected to simply strip off everything up to and including the last All type URL strings must be legal URI references with the additional restriction (for the text format) that the content of the reference must consist only of alphanumeric characters, percent-encoded escapes, and characters in the following set (not including the outer backticks): In the original design of |
value |
Holds a Protobuf serialization of the type described by type_url. A base64-encoded string. |
Status
| JSON representation |
|---|
{ "code": integer, "message": string, "details": [ { "@type": string, field1: ..., ... } ] } |
| Fields | |
|---|---|
code |
The status code, which should be an enum value of |
message |
A developer-facing error message, which should be in English. Any user-facing error message should be localized and sent in the |
details[] |
A list of messages that carry the error details. There is a common set of message types for APIs to use. An object containing fields of an arbitrary type. An additional field |
Tool Annotations
Destructive Hint: ❌ | Idempotent Hint: ❌ | Read Only Hint: ❌ | Open World Hint: ❌